#include "PushButton.h"

byte PushButton::_dbTime = 25;
byte PushButton::_ButtonChanged = false;

void PushButton::setPin(byte Pin) {
  _Pin = Pin;
  _Switch = 0;
  _RepeatSpeed = 0;
  pinMode(_Pin, INPUT_PULLUP);
}

bool PushButton::KeyDown(void) {
  uint32_t prevMillis = millis();
  _newState = !digitalRead(_Pin);
  if (_newState != _oldState) {
    if (prevMillis - _dbMillis > _dbTime) {
      _ButtonChanged = (_newState ? KEYDOWN : KEYUP);
      _oldState = _newState;
      if (_Switch) {
        if (_newState) _KeyDown = !_KeyDown;
      } else {
        _KeyDown = _newState;
      }
      _RepeatFirst = true;
    }
    _dbMillis = prevMillis;
    _RepeatMillis = prevMillis;
  } else {
    _ButtonChanged = UNCHANGED;
    if (_RepeatSpeed && _newState && prevMillis - _RepeatMillis > (_RepeatFirst ? 500 : _RepeatSpeed)) {
      _RepeatFirst = false;
      _ButtonChanged = KEYDOWN;
      _RepeatMillis = prevMillis;
      _KeyDown = !_KeyDown;
    }
  }
  return _KeyDown;
}

void PushButton::setState(bool Switch, uint16_t RepeatSpeed) {
  _Switch = Switch;
  _RepeatSpeed = RepeatSpeed;
}
