#ifndef PUSHBUTTON_H_INCLUDED
#define PUSHBUTTON_H_INCLUDED

#include <Arduino.h>

class PushButton {
  public:
    void setPin(byte);
    bool KeyDown(void);
    void setState(bool, uint16_t);
    static void setdbTime(byte dbTime) { _dbTime = dbTime; }
    static byte getdbTime(void) { return _dbTime; }
    static byte Changed(void) { return _ButtonChanged; }
  private:
    enum {UNCHANGED, KEYUP, KEYDOWN};
    byte _Pin;
    bool _newState = LOW;
    bool _oldState = LOW;
    bool _KeyDown = false;
    bool _RepeatFirst = false;
    bool _Switch = false;
    uint16_t _RepeatSpeed = 0;
    uint32_t _RepeatMillis = 0;
    uint32_t _dbMillis = 0;
    static byte _dbTime;
    static byte _ButtonChanged;
};

#endif // PUSHBUTTON_H_INCLUDED
